'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var authentication = function authentication(Component) {
  var Authentication = function (_React$Component) {
    _inherits(Authentication, _React$Component);

    function Authentication(props) {
      _classCallCheck(this, Authentication);

      var _this = _possibleConstructorReturn(this, (Authentication.__proto__ || Object.getPrototypeOf(Authentication)).call(this, props));

      _this.isAuthenticating = false;
      _this.authenticate(_this.props);
      return _this;
    }

    _createClass(Authentication, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        this.authenticate(nextProps);
      }
    }, {
      key: 'authenticate',
      value: function authenticate(_ref) {
        var isAuthenticated = _ref.isAuthenticated,
            goToLogin = _ref.goToLogin,
            actions = _ref.actions;

        if (isAuthenticated) {
          this.isAuthenticating = false;
          return true;
        }

        //  prevent to call goToLogin multiple times
        if (this.isAuthenticating) {
          return false;
        }
        this.isAuthenticating = true;

        if (goToLogin) {
          goToLogin();
          return false;
        }
        if (actions && actions.goToLogin) {
          actions.goToLogin();
          return false;
        }
        return false;
      }
    }, {
      key: 'render',
      value: function render() {
        if (!this.props.isAuthenticated) {
          return null;
        }
        return _react2.default.createElement(Component, this.props);
      }
    }]);

    return Authentication;
  }(_react2.default.Component);

  Authentication.propTypes = {
    isAuthenticated: _react.PropTypes.bool
  };
  Authentication.displayName = 'Authentication(' + (Component.displayName || Component.name) + ')';
  return Authentication;
};

exports.default = authentication;